unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, OpenGL12, CheckLst, ExtCtrls, Buttons, Menus,
  GLControl;

type
  TVector3f = array[0..2] of Single;
  TVector4f = array[0..3] of Single;

  // record to keep a device context/rendering context pair
  PContext = ^TContext;
  TContext = record
    DC: HDC;
    RC: HGLRC;
  end;                           

  TVersionInfo = record
    CompanyName,
    FileDescription,
    FileVersion,
    InternalName,
    LegalCopyright,
    OriginalFilename,
    ProductName,
    ProductVersion,
    Comments,
    LegalTrademarks: string;
  end;
  
  TMainForm = class(TForm)
    OkButton: TButton;
    PropertyPanel: TPanel;
    Label22: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Prop1Label: TLabel;
    Prop3Label: TLabel;
    Prop4Label: TLabel;
    Prop5Label: TLabel;
    Label64: TLabel;
    Prop2Label: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Prop6Label: TLabel;
    Prop8Label: TLabel;
    Prop9Label: TLabel;
    Prop10Label: TLabel;
    Label74: TLabel;
    Prop7Label: TLabel;
    PageControl2: TPageControl;
    InfoTabSheet: TTabSheet;
    Label13: TLabel;
    Label14: TLabel;
    SurfaceCombo: TComboBox;
    DepthComboBox: TComboBox;
    PageControl1: TPageControl;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    PFDCount: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    PixelTypeLabel: TLabel;
    ColorBitsLabel: TLabel;
    Label7: TLabel;
    AccumLabel: TLabel;
    Label9: TLabel;
    DepthLabel: TLabel;
    Label10: TLabel;
    StencilLabel: TLabel;
    Label11: TLabel;
    AuxLabel: TLabel;
    ColorPaintBox: TPaintBox;
    AccumPaintBox: TPaintBox;
    Label28: TLabel;
    OverlayLabel: TLabel;
    UnderlayLabel: TLabel;
    Label31: TLabel;
    PFDBrowseBtn: TUpDown;
    Panel2: TPanel;
    Label4: TLabel;
    Label15: TLabel;
    AccelLabel: TLabel;
    FlagsCheckBox: TCheckListBox;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    VendorLabel: TLabel;
    RendererLabel: TLabel;
    GLVersionLabel: TLabel;
    Label27: TLabel;
    GLUVersionLabel: TLabel;
    Panel1: TPanel;
    Label8: TLabel;
    ExtensionsCheckBox: TCheckListBox;
    TabSheet5: TTabSheet;
    GroupBox5: TGroupBox;
    Label29: TLabel;
    Label30: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    ClipLabel: TLabel;
    EvalLabel: TLabel;
    LightLabel: TLabel;
    ListLabel: TLabel;
    ModelviewLabel: TLabel;
    NameStackLabel: TLabel;
    PixelmapLabel: TLabel;
    ProjectionLabel: TLabel;
    TextureLabel: TLabel;
    TextureStackLabel: TLabel;
    ViewportLabel: TLabel;
    SubpixelLabel: TLabel;
    Label222: TLabel;
    AttribLabel: TLabel;
    Label45: TLabel;
    ClientAttribLabel: TLabel;
    GroupBox8: TGroupBox;
    Label46: TLabel;
    VerticesLabel: TLabel;
    IndicesLabel: TLabel;
    Label48: TLabel;
    MinLODLabel: TLabel;
    LODLabel: TLabel;
    Label51: TLabel;
    TextureLevelLabel: TLabel;
    Label44: TLabel;
    Texture3DLabel: TLabel;
    PrinterSetupDialog1: TPrinterSetupDialog;
    TabSheet7: TTabSheet;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    DisplayNameLabel: TLabel;
    DisplayManufacturerLabel: TLabel;
    DisplayChipLabel: TLabel;
    DisplayDACLabel: TLabel;
    DisplayMemoryLabel: TLabel;
    DisplayModeLabel: TLabel;
    Label25: TLabel;
    DisplayVersionLabel: TLabel;
    Label26: TLabel;
    DisplayLocationLabel: TLabel;
    GroupBox4: TGroupBox;
    Label21: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    DriverVDDLabel: TLabel;
    MainVersionButton: TSpeedButton;
    MiniVDDVersionButton: TSpeedButton;
    GroupBox10: TGroupBox;
    Label49: TLabel;
    Label50: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    ComputerNameLabel: TLabel;
    LanguageLabel: TLabel;
    ProcessorLabel: TLabel;
    MemoryLabel: TLabel;
    Label60: TLabel;
    OSLabel: TLabel;
    OpenGLSheet: TTabSheet;
    GroupBox6: TGroupBox;
    Label42: TLabel;
    Label43: TLabel;
    ConvWidthLabel: TLabel;
    ConvHeightLabel: TLabel;
    Label47: TLabel;
    ColorStackLabel: TLabel;
    GroupBox7: TGroupBox;
    Label54: TLabel;
    TextureUnitsLabel: TLabel;
    GroupBox9: TGroupBox;
    Label59: TLabel;
    PointSizeLabel: TLabel;
    Bevel1: TBevel;
    Timer1: TTimer;
    StatusBar: TStatusBar;
    ColorMenu: TPopupMenu;
    BkItem: TMenuItem;
    GLControl1: TGLControl;
    N1: TMenuItem;
    Addspheres1: TMenuItem;
    Removesphere1: TMenuItem;
    Togglepolygonmode1: TMenuItem;
    Togglefog1: TMenuItem;
    Toggleanimation1: TMenuItem;
    procedure PFDBrowseBtnClick(Sender: TObject; Button: TUDBtnType);
    procedure OkButtonClick(Sender: TObject);
    procedure SurfaceComboChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DepthComboBoxChange(Sender: TObject);
    procedure ColorPaintBoxPaint(Sender: TObject);
    procedure AccumPaintBoxPaint(Sender: TObject);
    procedure FileVersionButtonClick(Sender: TObject);
    procedure GLControl1Render(Sender: TWinControl);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PageControl2Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure PageControl2Change(Sender: TObject);
  private
    FBitmap: TBitmap;
    FWindowContext,
    FBitmapContext,
    FPrinterContext: TContext;
    FColorBits: array[1..32] of TColor;
    FAccumBits: array[1..64] of TColor;
    FNeedSetup,
    FUseFog: Boolean;
    FPolygonMode,
    FSlices,
    FStacks,
    FRingElementCount,
    FSphereList,
    FRingList,
    FCounter,
    FVertexCount,
    FTimeElapsed: Cardinal;
    procedure ReadPixelFormat(DC: HDC);
    procedure ReadDisplayProperties;
    procedure ReadLimits;
    procedure ReadComputerProperties;
    function ReadFileVersion(FileName: string): TVersionInfo;
    procedure BuildSphereList;
    procedure SetupOGLWindow;
    procedure BuildRingList;
    procedure ColorClick(Sender: TObject);
    procedure EnumColor(const ColorName: string);
    procedure ResetInfo; 
  public
    procedure AddPFD(pfd: TPixelFormatDescriptor);
  end;

var
  MainForm: TMainForm;
  IsWinNT,
  IsWin2K: Boolean;

//----------------------------------------------------------------------------------------------------------------------

implementation

uses
  Math, MMSystem, Printers;

{$R *.DFM}

const
  OneMegabyte = 1024 * 1024;
  
//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AddPFD(PFD: TPixelFormatDescriptor);

const
  DRIVER_MASK = PFD_GENERIC_FORMAT or PFD_GENERIC_ACCELERATED;

var
  I,
  AccumShift: Integer;
    
begin
  with PFD, FlagsCheckBox do
  begin
    Checked[0] := dwFlags and PFD_DOUBLEBUFFER <> 0;
    Checked[1] := dwFlags and PFD_STEREO <> 0;
    Checked[2] := dwFlags and PFD_DRAW_TO_WINDOW <> 0;
    Checked[3] := dwFlags and PFD_DRAW_TO_BITMAP <> 0;
    Checked[4] := dwFlags and PFD_SUPPORT_GDI <> 0;
    Checked[5] := dwFlags and PFD_SUPPORT_OPENGL <> 0;
    Checked[6] := dwFlags and PFD_GENERIC_FORMAT <> 0;
    Checked[7] := dwFlags and PFD_NEED_PALETTE <> 0;
    Checked[8] := dwFlags and PFD_NEED_SYSTEM_PALETTE <> 0;
    Checked[9] := dwFlags and PFD_SWAP_EXCHANGE <> 0;
    Checked[10] := dwFlags and PFD_SWAP_COPY <> 0;
    Checked[11] := dwFlags and PFD_SWAP_LAYER_BUFFERS <> 0;
    Checked[12] := dwFlags and PFD_GENERIC_ACCELERATED > 0;
    if (DRIVER_MASK and dwFlags) = 0 then
    begin
      AccelLabel.Caption := 'hardware accelerated (ICD)';
      AccelLabel.Font.Color := clGreen;
    end
    else
      if (DRIVER_MASK and dwFlags) = DRIVER_MASK then
      begin
        AccelLabel.Caption := 'partially hardware accelerated (MCD)';
        AccelLabel.Font.Color := clOlive;
      end
      else
        if (DRIVER_MASK and dwFlags) = PFD_GENERIC_FORMAT then
        begin
          AccelLabel.Caption := 'unaccelerated (software only)';
          AccelLabel.Font.Color := clRed;
        end
        else
        begin
          AccelLabel.Caption := 'no information available';
          AccelLabel.Font.Color := clGray;
        end;

    if iPixelType = PFD_TYPE_RGBA then
      PixelTypeLabel.Caption := 'RGBA mode'
    else
      PixelTypeLabel.Caption := 'Color index mode';

    ColorBitsLabel.Caption := IntToStr(cColorBits);
    for I := 1 to 32 do
      FColorBits[I] := clNone;
    for I := 1 + cAlphaShift to cAlphaBits + cAlphaShift do
      FColorBits[I] := clSilver;
    for I := 1 + cRedShift to cRedBits + cRedShift do
      FColorBits[I] := clRed;
    for I := 1 + cGreenShift to cGreenBits + cGreenShift do
      FColorBits[I] := clGreen;
    for I := 1 + cBlueShift to cBlueBits + cBlueShift do
      FColorBits[I] := clBlue;

    AccumLabel.Caption := IntToStr(cAccumBits);
    for I := 1 to 64 do
      FAccumBits[I] := clNone;
    AccumShift := cAccumRedBits + cAccumGreenBits + cAccumBlueBits;
    for I := 1 + AccumShift to cAccumAlphaBits + AccumShift do
      FAccumBits[I] := clSilver;
    Dec(AccumShift, cAccumRedBits);
    for I := 1 + AccumShift to cAccumRedBits + AccumShift do
      FAccumBits[I] := clRed;
    Dec(AccumShift, cAccumGreenBits);
    for I := 1 + AccumShift to cAccumGreenBits + AccumShift do
      FAccumBits[I] := clGreen;
    Dec(AccumShift, cAccumBlueBits);
    for I := 1 + AccumShift to cAccumBlueBits + AccumShift do
      FAccumBits[I] := clBlue;

    DepthLabel.Caption := Format('%d', [cDepthBits]);
    StencilLabel.Caption := Format('%d', [cStencilBits]);
    AuxLabel.Caption := Format('%d', [cAuxBuffers]);

    OverlayLabel.Caption := IntToStr(bReserved and 7);
    UnderlayLabel.Caption := IntToStr(bReserved shr 3);
  end;
  ColorPaintBox.Invalidate;
  AccumPaintBox.Invalidate;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.PFDBrowseBtnClick(Sender: TObject; Button: TUDBtnType);

begin
  case SurfaceCombo.ItemIndex of
    0:
      ReadPixelFormat(FWindowContext.DC);
    1:
      ReadPixelFormat(FBitmapContext.DC);
    2:
      ReadPixelFormat(FPrinterContext.DC);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.OkButtonClick(Sender: TObject);

begin
  Close;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ReadPixelFormat(DC: HDC);

var
  PFD: TPixelFormatDescriptor;

begin
  with PFDBrowseBtn do
  begin
    FillChar(PFD, SizeOf(PFD), #0);
    DescribePixelFormat(DC, Position + 1, SizeOf(PFD), PFD);
    AddPFD(PFD);
    PFDCount.Caption := Format('%d of %d', [Position + 1, Max + 1]);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ReadLimits;

// read various minimum/maximum values from current OpenGL implementation

var
  Value: Integer;
  VP: array[0..1] of Integer;

begin
  glGetIntegerv(GL_MAX_ATTRIB_STACK_DEPTH, @Value);
  AttribLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_CLIENT_ATTRIB_STACK_DEPTH, @Value);
  ClientAttribLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_CLIP_PLANES, @Value);
  ClipLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_EVAL_ORDER, @Value);
  EvalLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_LIGHTS, @Value);
  LightLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_LIST_NESTING, @Value);
  ListLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_MODELVIEW_STACK_DEPTH, @Value);
  ModelviewLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_NAME_STACK_DEPTH, @Value);
  NameStackLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_PIXEL_MAP_TABLE, @Value);
  PixelmapLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_PROJECTION_STACK_DEPTH, @Value);
  ProjectionLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_TEXTURE_SIZE, @Value);
  TextureLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_TEXTURE_STACK_DEPTH, @Value);
  TextureStackLabel.Caption := IntToStr(Value);
  glGetIntegerv(GL_MAX_VIEWPORT_DIMS, @VP);
  ViewportLabel.Caption := Format('%d x %d', [VP[0], VP[1]]);
  glGetIntegerv(GL_SUBPIXEL_BITS, @Value);
  SubpixelLabel.Caption := IntToStr(Value);

  // ARB imaging
  if GL_ARB_imaging then
  begin
    glGetIntegerv(GL_MAX_CONVOLUTION_WIDTH, @Value);
    ConvWidthLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_MAX_CONVOLUTION_HEIGHT, @Value);
    ConvHeightLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_MAX_COLOR_MATRIX_STACK_DEPTH, @Value);
    ColorStackLabel.Caption := IntToStr(Value);
  end
  else
  begin
    ConvWidthLabel.Caption := 'n/a';
    ConvHeightLabel.Caption := 'n/a';
    ColorStackLabel.Caption := 'n/a';
  end;

  if GL_VERSION_1_2 or GL_EXT_texture3D then
  begin
    glGetIntegerv(GL_MAX_3D_TEXTURE_SIZE, @Value);
    Texture3DLabel.Caption := IntToStr(Value);
  end
  else
  begin
    Texture3DLabel.Caption := 'n/a';
  end;

  if GL_VERSION_1_2 then
  begin
    glGetIntegerv(GL_MAX_ELEMENTS_VERTICES, @Value);
    VerticesLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_MAX_ELEMENTS_INDICES, @Value);
    IndicesLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_TEXTURE_MIN_LOD, @Value);
    LODLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_TEXTURE_MAX_LOD, @Value);
    LODLabel.Caption := LODLabel.Caption + '/' + IntToStr(Value);
    glGetIntegerv(GL_TEXTURE_MAX_LEVEL, @Value);
    TextureLevelLabel.Caption := IntToStr(Value);
  end
  else
  begin
    VerticesLabel.Caption := 'n/a';
    IndicesLabel.Caption := 'n/a';
    LODLabel.Caption := 'n/a';
    TextureLevelLabel.Caption := 'n/a';
  end;

  if GL_EXT_point_parameters then
  begin
    glGetIntegerv(GL_POINT_SIZE_MIN_EXT, @Value);
    PointSizeLabel.Caption := IntToStr(Value);
    glGetIntegerv(GL_POINT_SIZE_MAX_EXT, @Value);
    PointSizeLabel.Caption := PointSizeLabel.Caption + '/' + IntToStr(Value);
  end
  else
  begin
    PointSizeLabel.Caption := 'n/a';
  end;

  if GL_ARB_multitexture then
  begin
    glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB, @Value);
    TextureUnitsLabel.Caption := IntToStr(Value);
  end
  else
  begin
    TextureUnitsLabel.Caption := 'n/a';
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SurfaceComboChange(Sender: TObject);

const
  BitCounts: array [pf4Bit..pf32Bit] of Byte = (4, 8, 15, 16, 24, 32);

var
  PFD: TPixelFormatDescriptor;
  ColorDepth,
  I: Integer;
  Context: PContext;
  Extensions: string;
  Dummy: HPALETTE;

begin
  try
    Context := nil;
    if HasActiveContext then
      DeactivateRenderingContext;

    if Printer.Printing then
    begin
      DestroyRenderingContext(FPrinterContext.RC);
      Printer.Abort;
      FPrinterContext.RC := 0;
      FPrinterContext.DC := 0;
    end;

    case SurfaceCombo.ItemIndex of
      0:
        with FWindowContext do
        begin
          DepthComboBox.Enabled := False;
          if RC = 0 then
          begin
            // Note: Don't use Canvas.Handle as those DCs are only of temporary nature and may or may not
            //       differ on each access! Alternatively, you can use the same permanent lock as I have used for
            //       the bitmap canvas.
            if DC = 0 then
              DC := GetDC(Handle);
            ColorDepth := GetDeviceCaps(DC, BITSPIXEL) * GetDeviceCaps(DC, PLANES);
            RC := CreateRenderingContext(DC, [], ColorDepth, 0, 0, 0, 0, Dummy);
          end;
          ActivateRenderingContext(DC, RC);
          Context := @FWindowContext;
        end;
      1:
        with FBitmapContext do
        begin
          DepthComboBox.Enabled := True;
          if RC = 0 then
          begin
            if DC = 0 then
            begin
              // Need to lock the canvas permanently to prevent it from getting destroyed
              // by the garbage collector of the VCL.
              FBitmap.Canvas.Lock;
              DC := FBitmap.Canvas.Handle;
            end;
            ColorDepth := BitCounts[FBitMap.PixelFormat];
            RC := CreateRenderingContext(DC, [], ColorDepth, 0, 0, 0, 0, Dummy);
          end;
          ActivateRenderingContext(DC, RC);
          Context := @FBitmapContext;
        end;
      2: // A printer DC is a bit different as the user can pick different printers.
         // Hence we need to reset the context everytime...
        with FPrinterContext do
        begin
          DepthComboBox.Enabled := False;
          // Let the user pick one of the printers.
          if PrinterSetupDialog1.Execute then
          begin
            Printer.BeginDoc;
            DC := Printer.Handle;
            ColorDepth := GetDeviceCaps(DC, BITSPIXEL) * GetDeviceCaps(DC, PLANES);
            if ColorDepth < 4 then
            begin
              Printer.Abort;
              DC := 0;
              MessageDlg(Format('Cannot display information because the printer supports only %d color.'#13,
                [1 shl ColorDepth]) + 'OpenGL needs at least a color depth of 16 colors.', mtInformation, [mbOK], 0);
              Abort;
            end;
            RC := CreateRenderingContext(DC, [], ColorDepth, 0, 0, 0, 0, Dummy);
            ActivateRenderingContext(DC, RC);
            Context := @FPrinterContext;
          end
          else
          begin
            ResetInfo;
            Invalidate;
            Abort;
          end;
        end;
    else
      Abort;
    end;

    with Context^ do
    begin
      // Read driver information using:
      VendorLabel.Caption := glGetString(GL_VENDOR);
      RendererLabel.Caption := glGetString(GL_RENDERER);
      GLVersionLabel.Caption := glGetString(GL_VERSION);
      GLUVersionLabel.Caption := gluGetString(GLU_VERSION);
      Extensions := glGetString(GL_EXTENSIONS);
      Extensions := UpperCase(Extensions + ' ' + gluGetString(GLU_EXTENSIONS));
      with ExtensionsCheckBox do
        for I := 0 to Items.Count - 1 do
          Checked[I] := Pos(UpperCase(Items[I]), Extensions) > 0;
      ReadLimits;

      // Get pixel format information:
      with PFDBrowseBtn do
      begin
        Position := 0;
        Max := Integer(DescribePixelFormat(DC, 1, SizeOf(TPixelFormatDescriptor), PFD));
        if Max > 0 then
        begin
          Max := Max - 1;
          Enabled := True;
        end
        else
          Enabled := False;
        AddPFD(PFD);

        if Max = 0 then
          PFDCount.Caption := '0 of 0'
        else
          PFDCount.Caption := Format('%d of %d', [Position + 1, Max + 1]);
      end;
    end;
  except
    // reset to known state in case of a failure
    SurfaceCombo.ItemIndex := -1;
    DepthComboBox.Enabled := False;
    DepthComboBox.ItemIndex := 4;
    FBitmapContext.DC := 0;
    if FBitmap.Canvas.LockCount > 0 then
      FBitmap.Canvas.Unlock;
    FBitmap.PixelFormat := pf32Bit;
    raise;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormCreate(Sender: TObject);

var
  I: Integer;

begin
  InitOpenGL;
  FBitmap := TBitmap.Create;
  with FBitmap do
  begin
    Width := 10;
    Height := 10;
    PixelFormat := pf32Bit;
  end;
  ResetInfo;
  ReadComputerProperties;
  ReadDisplayProperties;
  // A panel which serves as popup replacement.
  with PropertyPanel do
  begin
    Parent := nil;
    ParentWindow := GetDesktopWindow;
    SetWindowLong(Handle, GWL_EXSTYLE, GetWindowLong(Handle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW);
  end;

  // init other variables
  FNeedSetup := True;
  FCounter := 0;
  // resolution of the base sphere
  FSlices := 20;
  FStacks := 20;
  // number of elements in one ring
  FRingElementCount := 10;

  GetColorValues(EnumColor);
  with BkItem do
    for I := 1 to Count - 1 do
      if (I mod 16) = 0 then
        Items[I].Break := mbBarBreak;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.EnumColor(const ColorName: string);

begin
  BkItem.Add(NewItem(ColorName, 0, False, True, ColorClick, 0, ColorName + 'Item'));
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ColorClick(Sender: TObject);

begin
  GLControl1.Background := StringToColor(TMenuItem(Sender).Caption);
  FNeedSetup := True;
  if not Timer1.Enabled then
    GLControl1.Invalidate;
end;

//----------------------------------------------------------------------------------------------------------------------

function TMainForm.ReadFileVersion(FileName: string): TVersionInfo;

var
  Size,
  Dummy: Cardinal;
  Buffer: Pointer;
  Data: Pointer;
  QueryString: string;
  Path: array[0..MAX_PATH] of Char;

begin
  // The given file name contains usually not a valid path so I rely on the
  // ability of the version functions to find the entire path. If this fails then
  // I do the long way and do a search through the Windows directory.
  Size := GetFileVersionInfoSize(PChar(FileName), Dummy);
  if Size = 0 then
  begin
    // looking up the file path fails usually when the file is not in the search path
    // since we are dealing with drivers here it is very likely the file is in the drivers folder
    GetSystemDirectory(Path, MAX_PATH);
    FileName := Path + '\drivers\' + FileName;
    Size := GetFileVersionInfoSize(PChar(FileName), Dummy);
  end;
  if Size > 0 then
  begin
    Buffer := AllocMem(Size);
    try
      GetFileVersionInfo(PChar(FileName), 0, Size, Buffer);
      // to retrive other values we need to determine a languge from the file,
      // usually there's only one and I don't bother with several ones anyway
      VerQueryValue(Buffer, '\VarFileInfo\Translation', Data, Size);
      // Data points now to a set of word pairs (for each code page one pair) and
      // Size contains the size of the array in bytes
      // We need to convert the first pair into a hex string but both words need to
      // have 4 digits and the order is reversed...
      QueryString := Format('\StringFileInfo\%.4x%.4x', [PDWORD(Data)^ and $FFFF, PDWORD(Data)^ shr 16]);
      // now we can read all other values
      with Result do
      begin
        VerQueryValue(Buffer, PChar(QueryString + '\CompanyName'), Data, Size);
        SetString(CompanyName, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\FileDescription'), Data, Size);
        SetString(FileDescription, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\FileVersion'), Data, Size);
        SetString(FileVersion, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\InternalName'), Data, Size);
        SetString(InternalName, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\LegalCopyright'), Data, Size);
        SetString(LegalCopyright, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\OriginalFilename'), Data, Size);
        SetString(OriginalFilename, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\ProductName'), Data, Size);
        SetString(ProductName, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\ProductVersion'), Data, Size);
        SetString(ProductVersion, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\Comments'), Data, Size);
        SetString(Comments, PChar(Data), Size);
        VerQueryValue(Buffer, PChar(QueryString + '\LegalTrademarks'), Data, Size);
        SetString(LegalTrademarks, PChar(Data), Size);
      end;
    finally
      FreeMem(Buffer);
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ReadComputerProperties;

var
  Buffer: array[0..MAX_PATH] of Char;
  Size: Cardinal;
  VI: TOSVersionInfo;
  S: string;
  Key: HKEY;
  Memory: TMemoryStatus;

begin
  Size := SizeOf(Buffer);
  GetComputerName(Buffer, Size);
  ComputerNameLabel.Caption := Buffer;
  S := '';
  if IsWinNT then
  begin
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'SOFTWARE\Microsoft\Windows NT\CurrentVersion', 0, KEY_READ,
      Key) = ERROR_SUCCESS then
    begin
      Size := SizeOf(Buffer);
      if RegQueryValueEx(Key, 'ProductName', nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
        S := Buffer
      else // we know it's Windows NT
        S := 'Microsoft Windows NT';
      RegCloseKey(Key);
    end;
    VI.dwOSVersionInfoSize := SizeOf(VI);
    if GetVersionEx(VI) then
    begin
      with VI do
      begin
        IsWin2K := IsWInNT and (dwMajorVersion > 4);
        OSLabel.Caption := S + ' (' + IntToStr(dwMajorVersion) + '.' + IntToStr(dwMinorVersion) + ' Build ' +
          IntToStr(dwBuildNumber) + ')';
      end;
    end;
  end
  else
  begin
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'Software\Microsoft\Windows\CurrentVersion', 0, KEY_READ,
      Key) = ERROR_SUCCESS then
    begin
      Size := SizeOf(Buffer);
      if RegQueryValueEx(Key, 'ProductName', nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
        OSLabel.Caption := Buffer;
      Size := SizeOf(Buffer);
      if RegQueryValueEx(Key, 'VersionNumber', nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
      begin
        S :=  ' (' + Buffer + ')';
        Size := SizeOf(Buffer);
        if RegQueryValueEx(Key, 'SubVersionNumber', nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
          S := S + Buffer;
      end;
      if S <> '' then OSLabel.Caption := OSLabel.Caption + S;
      RegCloseKey(Key);
    end;
  end;
  
  // language info
  GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SLANGUAGE or LOCALE_NOUSEROVERRIDE, Buffer, SizeOf(Buffer));
  LanguageLabel.Caption := Buffer;
  
  // processor information from registry
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'HARDWARE\DESCRIPTION\System\CentralProcessor\0', 0, KEY_READ,
    Key) = ERROR_SUCCESS then
  begin
    Size := SizeOf(Buffer);
    if IsWinNT then
      S := 'ProcessornameString'
    else
      S := 'Identifier';
    if RegQueryValueEx(Key, PChar(S), nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
      S := Buffer
    else
    begin
      // ProcessorNameString isnt' there so try "Identifier"
      S := 'Identifier';
      if RegQueryValueEx(Key, PChar(S), nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
        S := Buffer
    end;
    Size := SizeOf(Buffer);
    if RegQueryValueEx(Key, '~Mhz', nil, nil, @Buffer, @Size) = ERROR_SUCCESS then
      S := S + ', ' + IntToStr(PDWORD(@Buffer)^) + ' MHz';
    ProcessorLabel.Caption := S;
    RegCloseKey(Key);
  end;

  Memory.dwLength := SizeOf(Memory);
  GlobalMemoryStatus(Memory);
  with Memory do
  begin
    MemoryLabel.Caption := Format('physical %.1f MB (available %.1f MB), ',
      [dwTotalPhys / OneMegaByte, dwAvailPhys / OneMegabyte]) +
      Format('virtual %.1f MB (available %.1f MB)', [dwTotalPageFile / OneMegaByte, dwAvailPageFile / OneMegabyte]);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

const
  CurrentControlSetClasses = 'SYSTEM\CurrentControlSet\Control\Class';

function GetDisplayClassKey: string;

// iterate through the class section of the current control set to find the (first) "Display" key

var
  ClassKey,
  GUIDKey: HKEY;
  GUIDBuffer,
  ClassBuffer: array[0..MAX_PATH] of Char;
  Index,
  ValueSize: Integer;

begin
  Result := '';
  if RegOpenKeyEx(HKEY_LOCAL_MACHINE, CurrentControlSetClasses, 0, KEY_READ, ClassKey) = ERROR_SUCCESS then
  begin
    // walk through all keys until we find one which contains the class value "Display"
    Index := 0;
    while RegEnumKey(ClassKey, Index, GUIDBuffer, SizeOf(GUIDBuffer)) = ERROR_SUCCESS do
    begin
      // read the class ID of this key
      if RegOpenKeyEx(ClassKey, GUIDBuffer, 0, KEY_READ, GUIDKey) = ERROR_SUCCESS then
      begin
        ValueSize := SizeOf(ClassBuffer);
        if (RegQueryValueEx(GUIDKey, 'Class', nil, nil, @ClassBuffer, @ValueSize) = ERROR_SUCCESS) and
           (CompareText(ClassBuffer, 'Display') = 0) then
        begin
          Result := GUIDBuffer;
          RegCloseKey(GUIDKey);
          Break;
        end;
        RegCloseKey(GUIDKey);
      end;
      Inc(Index);
    end;
    RegCloseKey(ClassKey);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ReadDisplayProperties;

// Fills the "Display" sheet with display (driver) related data.
// I found no better way than to directly read out the registry. Note that there are
// a few differences between Win9x and WinNT (WinNT is synonymically used with Win2000).

var
  BaseKey,
  SettingsKey,
  DeviceKey: HKEY;
  Status: Integer;
  ValueSize: Cardinal;
  Index: Integer;
  ValueName,
  ServiceName,
  DeviceID,
  EnumGroup: string;
  Buffer: array[0..MAX_PATH] of Char;
  DC: HDC;

begin
  // first step is to locate the currently installed display driver
  if IsWinNT then
    ValueName := CurrentControlSetClasses + '\' + GetDisplayClassKey + '\0000'
  else
    ValueName := 'System\CurrentControlSet\Services\Class\Display\0000';
  Status := RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(ValueName), 0, KEY_READ, BaseKey);
  if Status = ERROR_SUCCESS then
  begin
    // read out description, driver DLL and device ID
    ValueSize := SizeOf(Buffer);
    if RegQueryValueEx(BaseKey, 'DriverDesc', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
      DisplayNameLabel.Caption := Buffer;
    ValueSize := SizeOf(Buffer);
    if IsWinNT then
    begin
      if RegQueryValueEx(BaseKey, 'DriverVersion', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DisplayVersionLabel.Caption := Buffer;
      DriverVDDLabel.Caption := '';
    end
    else
    begin
      if RegQueryValueEx(BaseKey, 'Ver', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DisplayVersionLabel.Caption := '(Software) ' + Buffer;
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'DevLoader', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DriverVDDLabel.Caption := Buffer;
    end;

    if IsWinNT then
    begin
      Status := RegOpenKeyEx(BaseKey, 'Settings', 0, KEY_READ, SettingsKey);
      if Status = ERROR_SUCCESS then
      begin
        ValueSize := SizeOf(Buffer);
        DeviceID := '';
        if RegQueryValueEx(BaseKey, 'MatchingDeviceId', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
          DeviceID := Buffer;
        RegCloseKey(SettingsKey);
      end;
    end
    else
    begin
      ValueSize := SizeOf(Buffer);
      DeviceID := '';
      if RegQueryValueEx(BaseKey, 'MatchingDeviceId', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DeviceID := Buffer;
    end;
    RegCloseKey(BaseKey);
  end;

  ServiceName := '';
  if not IsWinNT or IsWin2K then
  begin
    // Now that we have the device ID we can go to the second step and
    // find the manufacturer and the associated service name (NT only) we need to look up
    // yet another values... Unfortunately the device ID is not complete and contains only
    // the first part of the final registry key, so we still have to enumerate.
    EnumGroup := Copy(DeviceID, 1, Pos('\', DeviceID) - 1);
    Delete(DeviceID, 1, Length(EnumGroup) + 1);
    DeviceID := UpperCase(DeviceID);
    if IsWinNT then
      EnumGroup := 'System\CurrentControlSet\Enum\' + EnumGroup
    else
      EnumGroup := 'Enum\' + EnumGroup;
    Status := RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(EnumGroup), 0, KEY_READ, BaseKey);
    if Status = ERROR_SUCCESS then
    begin
      ValueName := '';
      // iterate through all devices under the current enumeration group
      Index := 0;
      while RegEnumKey(BaseKey, Index, Buffer, SizeOf(Buffer)) = ERROR_SUCCESS do
      begin
        if Pos(DeviceID, UpperCase(Buffer)) = 1 then
        begin
          // Fine, we found the key, now open its first subkey to get finally to the data.
          // As the name of the first key varies, we have to enumerate it...
          if RegOpenKeyEx(BaseKey, Buffer, 0, KEY_READ, SettingsKey) = ERROR_SUCCESS then
          begin
            if RegEnumKey(SettingsKey, 0, Buffer, SizeOf(Buffer)) = ERROR_SUCCESS then
            begin
              if RegOpenKeyEx(SettingsKey, Buffer, 0, KEY_READ, DeviceKey) = ERROR_SUCCESS then
              begin
                ValueSize := SizeOf(Buffer);
                if RegQueryValueEx(DeviceKey, 'LocationInformation', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
                  DisplayLocationLabel.Caption := Buffer;
                ValueSize := SizeOf(Buffer);
                if RegQueryValueEx(DeviceKey, 'Mfg', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
                  DisplayManufacturerLabel.Caption := Buffer;
                ValueSize := SizeOf(Buffer);
                if RegQueryValueEx(DeviceKey, 'Service', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
                  ServiceName := Buffer;
                RegCloseKey(DeviceKey);
              end;
            end;
            RegCloseKey(SettingsKey);
          end;
          Break;
        end;
        Inc(Index);
      end;
      RegCloseKey(BaseKey);
    end;
  end
  else
  begin
    // Finding the manufacturer and the associated service name is totally different
    // under WinNT 4.
    EnumGroup := 'System\CurrentControlSet\Enum\Root';
    Status := RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(EnumGroup), 0, KEY_READ, BaseKey);
    if Status = ERROR_SUCCESS then
    begin
      ValueName := '';
      // iterate through all devices under the current enumeration group
      Index := 0;
      while RegEnumKey(BaseKey, Index, Buffer, SizeOf(Buffer)) = ERROR_SUCCESS do
      begin
        // open first sub key under this device key
        if RegOpenKeyEx(BaseKey, PChar(Buffer + '\0000'), 0, KEY_READ, SettingsKey) = ERROR_SUCCESS then
        begin
          ValueSize := SizeOf(Buffer);
          if (RegQueryValueEx(SettingsKey, 'Class', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS) and
             (CompareText(Buffer, 'Display') = 0) then
          begin
            ValueSize := SizeOf(Buffer);
            if RegQueryValueEx(SettingsKey, 'Mfg', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
              DisplayManufacturerLabel.Caption := Buffer;
            ValueSize := SizeOf(Buffer);
            if RegQueryValueEx(SettingsKey, 'Service', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
              ServiceName := Buffer;
          end;
          RegCloseKey(SettingsKey);
        end;
        if ServiceName <> '' then Break;
        Inc(Index);
      end;
      RegCloseKey(BaseKey);
    end;
  end;

  // finally the service behind the display driver can be queried for additional information
  // under WinNT, unfortunately this information is not available under Win9x
  if IsWinNT and (ServiceName <> '') then
  begin
    ValueName := 'SYSTEM\CurrentControlSet\Services\' + ServiceName;
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(ValueName), 0, KEY_READ, BaseKey) = ERROR_SUCCESS then
    begin
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'ImagePath', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
      begin
        MiniVDDVersionButton.Caption := ExtractFileName(Buffer);
      end;
      if RegOpenKeyEx(BaseKey, 'Device0', 0, KEY_READ, DeviceKey) = ERROR_SUCCESS then
      begin
        ValueSize := SizeOf(Buffer);
        if RegQueryValueEx(DeviceKey, 'InstalledDisplayDrivers', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        begin
          if Pos('.', Buffer) = 0 then
            MainVersionButton.Caption := Buffer + '.dll'
          else
            MainVersionButton.Caption := Buffer;
        end;
        ValueSize := SizeOf(Buffer);
        if RegQueryValueEx(DeviceKey, 'HardwareInformation.ChipType', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
          DisplayChipLabel.Caption := PWideChar(@Buffer);
        ValueSize := SizeOf(Buffer);
        if RegQueryValueEx(DeviceKey, 'HardwareInformation.DacType', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
          DisplayDacLabel.Caption := PWideChar(@Buffer);
        ValueSize := SizeOf(Buffer);
        if RegQueryValueEx(DeviceKey, 'HardwareInformation.MemorySize', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
          DisplayMemoryLabel.Caption := Format('%.1f MB', [PDWORD(@Buffer)^ / OneMegabyte]);
        RegCloseKey(DeviceKey);
      end;
      RegCloseKey(BaseKey);
    end;
  end
  else
  begin
    // under Win9x there are still a few facts to report
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'System\CurrentControlSet\Services\Class\Display\0000\DEFAULT',
      0, KEY_READ, BaseKey) = ERROR_SUCCESS then
    begin
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'minivdd', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        MiniVDDVersionButton.Caption := ExtractFileName(Buffer);
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'minivdd2', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DriverVDDLabel.Caption := DriverVDDLabel.Caption + ' (' + ExtractFileName(Buffer) + ')';
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'vdd', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        DriverVDDLabel.Caption := ExtractFileName(Buffer);
      ValueSize := SizeOf(Buffer);
      if RegQueryValueEx(BaseKey, 'drv', nil, nil, @Buffer, @ValueSize) = ERROR_SUCCESS then
        MainVersionButton.Caption := ExtractFileName(Buffer);
      RegCloseKey(BaseKey);
    end;
  end;

  MainVersionButton.Enabled := MainVersionButton.Caption <> '';
  MiniVDDVersionButton.Enabled := MiniVDDVersionButton.Caption <> '';
  DC := GetDC(0);
  ValueSize := GetDeviceCaps(DC, BITSPIXEL) * GetDeviceCaps(DC, PLANES);
  DisplayModeLabel.Caption := Format('%d x %d (%d bit)', [Screen.Width, Screen.Height, ValueSize]);
  ReleaseDC(0, DC);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormDestroy(Sender: TObject);

begin
  if HasActiveContext then
    DeactivateRenderingContext;
  with FWindowContext do
    if RC <> 0 then
      DestroyRenderingContext(RC);
  with FBitmapContext do
    if RC <> 0 then
      DestroyRenderingContext(RC);
  with FPrinterContext do
    if RC <> 0 then
      DestroyRenderingContext(RC);
  if Printer.Printing then
    Printer.Abort;

  if FBitmap.Canvas.LockCount > 0 then
    FBitmap.Canvas.Unlock;
  FBitmap.Free;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.DepthComboBoxChange(Sender: TObject);

begin
  with DepthComboBox do
  begin
    DeactivateRenderingContext;
    DestroyRenderingContext(FBitmapContext.RC);
    FBitmapContext.RC := 0;
    FBitmapContext.DC := 0;
    if FBitmap.Canvas.LockCount > 0 then
      FBitmap.Canvas.Unlock;
    case ItemIndex of
      0:
        FBitmap.PixelFormat := pf4Bit;
      1:
        FBitmap.PixelFormat := pf8Bit;
      2:
        FBitmap.PixelFormat := pf16Bit;
      3:
        FBitmap.PixelFormat := pf24Bit;
      4:
        FBitmap.PixelFormat := pf32Bit;
    end;
    SurfaceComboChange(nil);
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ColorPaintBoxPaint(Sender: TObject);

// draw a visual representation of the color bits configuration

var
  I: Integer;
  R: TRect;
  BoxWidth: Integer;

begin
  with ColorPaintBox do
  begin
    // determine size of one color quad
    BoxWidth := Trunc(ClientWidth / 32.5);
    R := Rect(0, 2, BoxWidth - 1, Height - 2);
    Canvas.Pen.Color := clBtnShadow;
    for I := 32 downto 1 do
    begin
      if FColorBits[I] = clNone then
        Canvas.Brush.Style := bsClear
      else
        Canvas.Brush.Color := FColorBits[I];
      with R do
        Canvas.Rectangle(R.Left, R.Top, R.Right, R.Bottom);
      if I = 17 then
        OffsetRect(R, BoxWidth div 2, 0);
      OffsetRect(R, BoxWidth, 0);
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.AccumPaintBoxPaint(Sender: TObject);

// draw a visual representation of the accumulator bits configuration

var
  I: Integer;
  R: TRect;
  BoxWidth: Integer;

begin
  with AccumPaintBox do
  begin
    // determine size of one color quad
    BoxWidth := Trunc(ClientWidth / 66);
    R := Rect(0, 2, BoxWidth - 1, Height - 2);
    Canvas.Pen.Color := clBtnShadow;
    for I := 64 downto 1 do
    begin
      if FAccumBits[I] = clNone then
        Canvas.Brush.Style := bsClear
      else
        Canvas.Brush.Color := FAccumBits[I];
      with R do
        Canvas.Rectangle(R.Left, R.Top, R.Right, R.Bottom);
      case I of
        17, 49:
          OffsetRect(R, BoxWidth div 2, 0);
        33:
          OffsetRect(R, BoxWidth, 0);
      end;
      OffsetRect(R, BoxWidth, 0);
     end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FileVersionButtonClick(Sender: TObject);

var
  VersionInfo: TVersionInfo;
  P: TPoint;
  SP: TSmallPoint;
  Msg: TMsg;
  MaxLen: Integer;

begin
  VersionInfo := ReadFileVersion((Sender as TSpeedButton).Caption);
  with PropertyPanel, VersionInfo do
  begin
    Prop1Label.Caption := CompanyName;
    MaxLen := Prop1Label.Width;
    Prop2Label.Caption := FileDescription;
    if Prop2Label.Width > MaxLen then
      MaxLen := Prop2Label.Width;
    Prop3Label.Caption := FileVersion;
    if Prop3Label.Width > MaxLen then
      MaxLen := Prop3Label.Width;
    Prop4Label.Caption := InternalName;
    if Prop4Label.Width > MaxLen then
      MaxLen := Prop4Label.Width;
    Prop5Label.Caption := LegalCopyright;
    if Prop5Label.Width > MaxLen then
      MaxLen := Prop5Label.Width;
    Prop6Label.Caption := OriginalFilename;
    if Prop6Label.Width > MaxLen then
      MaxLen := Prop6Label.Width;
    Prop7Label.Caption := ProductName;
    if Prop7Label.Width > MaxLen then
      MaxLen := Prop7Label.Width;
    Prop8Label.Caption := ProductVersion;
    if Prop8Label.Width > MaxLen then
      MaxLen := Prop8Label.Width;
    Prop9Label.Caption := LegalTrademarks;
    if Prop9Label.Width > MaxLen then
      MaxLen := Prop9Label.Width;
    Prop10Label.Caption := Comments;
    if Prop10Label.Width > MaxLen then
      MaxLen := Prop10Label.Width;
    // position of the mouse at the time the button was clicked
    DWORD(SP) := GetMessagePos;
    // make MaxLen the width of the panel 
    MaxLen := Prop1Label.Left + MaxLen + 5;
    with Sender as TSpeedButton do
    begin
      P := Point(0, Top + Height);
      P := Parent.ClientToScreen(P);
    end;
    // keep the panel on the screen as long as the user doesn't click the mouse
    with PropertyPanel do
    begin
      SetWindowPos(Handle, HWND_TOPMOST, SP.X - MaxLen div 2, P.Y, MaxLen, Height, SWP_SHOWWINDOW);
      UpdateWindow(Handle);
      UpdateWindow(Self.Handle);
      SetCapture(Handle);
      SetFocus;

      while GetMessage(Msg, Handle, 0, 9999) do
      begin
        if (Msg.message = WM_LBUTTONDOWN) or (Msg.message = WM_RBUTTONDOWN) or (Msg.message = WM_MBUTTONDOWN) then
          Break;
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;

      ReleaseCapture;
      ShowWindow(Handle, SW_HIDE);
    end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.BuildSphereList;

// creates the base sphere display list used in the OpenGL test window
// Note: There must be an active rendering context in the thread!

var
  V1, V2 : TVector3f;
  AngTop, AngBottom,
  AngStart, AngStop,
  StepV, StepH,
  SinP, CosP,
  SinP2, CosP2,
  SinT, CosT,
  Phi, Phi2,
  Theta: Extended;
  I, J: Integer;

begin
  // common settings
  AngTop := Pi / 2;
  AngBottom := -Pi / 2;
  AngStart := 0;
  AngStop := 2 * Pi;
  StepH := (AngStop-AngStart) / FSlices;
  StepV := (AngTop-AngBottom) / FStacks;
  if FSphereList = 0 then
    FSphereList := glGenLists(1);

  glNewList(FSphereList, GL_COMPILE);
    Phi := AngTop;
    Phi2 := Phi-StepV;
    for J := 0 to FStacks - 1 do
    begin
      Theta := AngStart;
      SinCos(Phi, SinP, CosP);
      SinCos(Phi2, SinP2, CosP2);
      V1[1] := SinP;
      V2[1] := SinP2;
      glBegin(GL_TRIANGLE_STRIP);
      for I := 0 to FSlices do
      begin
        SinCos(Theta, SinT, CosT);
        V1[0] := CosP * SinT;
        V2[0] := CosP2 * SinT;
        V1[2] := CosP * CosT;
        V2[2] := CosP2 * CosT;
        glTexCoord2f(I / FSlices, J / (FStacks - 1));
        glNormal3fv(@V1);
        glVertex3fv(@V1);
        Inc(FVertexCount);

        glTexCoord2f(I / FSlices, (J + 1) / (FStacks - 1));
        glNormal3fv(@V2);
        glVertex3fv(@V2);
        Inc(FVertexCount);

        Theta := Theta + StepH;
      end;
      glEnd;
      Phi := Phi2;
      Phi2 := Phi2 - StepV;
    end;
  glEndList;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure ModifyColor(Range: Extended; var Color: TVector4f; dColor: Extended);

// advance the color vector so that we get a perfect rainbow
// Ranges are defined as (starting with pure red):
// 0..1: increase blue by dColor
// 1..2: decrease red
// 2..3: increase green
// 3..4: decrease blue
// 4..5: increase red
// 5..6: decrease green

begin
  if Range < 1 then
  begin
    Color[0] := 1;
    Color[1] := 0;
    Color[2] := Range;
  end
  else
    if Range < 2 then
    begin
      Color[0] := 2 - Range;
      Color[1] := 0;
      Color[2] := 1;
    end
    else
      if Range < 3 then
      begin
        Color[0] := 0;
        Color[1] := Range - 2;
        Color[2] := 1;
      end
      else
        if Range < 4 then
        begin
          Color[0] := 0;
          Color[1] := 1;
          Color[2] := 4 - Range;
        end
        else
          if Range < 5 then
          begin
            Color[0] := Range - 4;
            Color[1] := 1;
            Color[2] := 0
          end
          else
          begin
            Color[0] := 1;
            Color[1] := 6 - Range;
            Color[2] := 0
          end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.BuildRingList;

// creates the display list for one ring of spheres

const
  Ambient: TVector4f = (0.2, 0.2, 0.2, 1);
  Specular: TVector4f = (1, 1, 1, 1);

var
  I: Integer;
  SinA, CosA,
  Delta,
  dColor: Extended;
  Radius: Cardinal;
  Diffuse: TVector4f;

begin
  if FRingList = 0 then
    FRingList := glGenLists(1);
  // radius of a ring is 5 times the radius of a sphere (which is by default 1)
  Radius := 5;
  glNewList(FRingList, GL_COMPILE);
  Delta := 2 * Pi / FRingElementCount;
  // difference in color for one step (3 base colors (RGB) plus  intermediate values)
  dColor := 6 / FRingElementCount;
  for I := 0 to FRingElementCount - 1 do
  begin
    // save the current transformation matrix, we need it later again
    glPushMatrix;
    // move the sphere to its final place
    SinCos(I * Delta, SinA, CosA);
    glTranslatef(Radius * CosA, Radius * SinA, 0);

    // set a fancy material
    glMateriali(GL_FRONT, GL_SHININESS, 128);
    glMaterialfv(GL_FRONT, GL_AMBIENT, @Ambient);
    ModifyColor(6 * I / FRingElementCount, Diffuse, dColor);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, @Diffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, @Specular);

    glCallList(FSphereList);
    // restore old transformation values
    glPopMatrix;
  end;
  glEndList;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.SetupOGLWindow;

// creates all display lists and sets up the environment for the OpenGL test window

const
  LightPos1: TVector4f = (-30, 30, 30, 1);
  LightPos2: TVector4f = (50, 100, 50, 1);

  Ambient: TVector4f = (0.2, 0.2, 0.2, 1);
  Diffuse1: TVector4f = (0.5, 0.5, 0.5, 1);
  Diffuse2: TVector4f = (0.5, 0.5, 0.5, 1);
  Specular: TVector4f = (1, 1, 1, 1);

var
  FogColor: TVector4f;
  BackColor: COLORREF;

begin
  FNeedSetup := False;
  // base display lists
  FVertexCount := 0;
  BuildSphereList;
  FVertexCount := 3 * FRingElementCount * FVertexCount;
  Statusbar.Panels[0].Text := Format('Vertices: %d', [FVertexCount]);
  BuildRingList;

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);

  // setup light sources
  glEnable(GL_LIGHTING);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);

  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_POSITION, @LightPos1);
  glLightfv(GL_LIGHT0, GL_AMBIENT, @Ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @Diffuse1);
  glLightfv(GL_LIGHT0, GL_SPECULAR, @Specular);

  glEnable(GL_LIGHT1);
  glLightfv(GL_LIGHT1, GL_POSITION, @LightPos2);
  glLightfv(GL_LIGHT1, GL_AMBIENT, @Ambient);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, @Diffuse2);
  glLightfv(GL_LIGHT1, GL_SPECULAR, @Specular);

  if FUseFog then
  begin
    glEnable(GL_FOG);
    glFogi(GL_FOG_MODE, GL_LINEAR);
    BackColor := ColorToRGB(GLControl1.Background);
    FogColor[0] := GetRValue(BackColor);
    FogColor[1] := GetGValue(BackColor);
    FogColor[2] := GetBValue(BackColor);
    glFogfv(GL_FOG_COLOR, @FogColor);
    glFogf(GL_FOG_START, 10);
    glFogf(GL_FOG_END, 100);
    glHint(GL_FOG_HINT, GL_NICEST);
  end
  else glDisable(GL_FOG);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.GLControl1Render(Sender: TWinControl);

begin
  if FNeedSetup then SetupOGLWindow;
  if Timer1.Enabled and ((FCounter mod 10) = 0) then
    FTimeElapsed := timeGetTime;

  gluLookAt(0, 0, 20, 0, 0, -10, 0, 1, 0);
  case FPolygonMode of
    0:
      glPolygonMode(GL_FRONT, GL_FILL);
    1:
      glPolygonMode(GL_FRONT, GL_LINE);
    2:
      glPolygonMode(GL_FRONT, GL_POINT);
  end;

  glRotatef(FCounter div 2, 0, 0, 1);
  glCallList(FRingList);
  glRotatef(-Integer(FCounter), 0, 0, 1);
  glTranslatef(0, 0, -20);
  glCallList(FRingList);
  glRotatef(2 * FCounter, 0, 0, 1);
  glTranslatef(0, 0, -20);
  glCallList(FRingList);

  if Timer1.Enabled and ((FCounter mod 10) = 9) then
    StatusBar.Panels[1].Text := Format('%f fps', [10000 / (timeGetTime - FTimeElapsed)]);
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.Timer1Timer(Sender: TObject);

begin
  FCounter := (FCounter + 1) mod 720;
  GLControl1.Refresh;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);

// handles a few keystrokes to modify the scene displayed in the OpenGL window

begin
  case Key of
    '+':
      if FRingElementCount < 50 then
      begin
        Inc(FRingElementCount);
        FNeedSetup := True;
        if not Timer1.Enabled then
          GLControl1.Invalidate;
      end;
    '-':
      if FRingElementCount > 6 then
      begin
        Dec(FRingElementCount);
        FNeedSetup := True;
        if not Timer1.Enabled then
          GLControl1.Invalidate;
      end;
    'W', 'w':
      begin
        FPolygonMode := (FPolygonMode + 1) mod 3;
        if not Timer1.Enabled then
          GLControl1.Invalidate;
      end;
    'A', 'a':
      Timer1.Enabled := not Timer1.Enabled;
    'F', 'f':
      begin
        FUseFog := not FUseFog;
        FNeedSetup := True;
        if not Timer1.Enabled then
          GLControl1.Invalidate;
      end;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.PageControl2Change(Sender: TObject);

begin
  Timer1.Enabled := PageControl2.ActivePage = OpenGLSheet;

  if PageControl2.ActivePage = OpenGLSheet then
    GLControl1.EnableContext
  else
    GLControl1.DisableContext;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.PageControl2Changing(Sender: TObject; var AllowChange: Boolean);

begin
  if PageControl2.ActivePage = InfoTabSheet then
  begin
    if HasActiveContext then
      DeactivateRenderingContext;
  end;
end;

//----------------------------------------------------------------------------------------------------------------------

procedure TMainForm.ResetInfo;

var
  I: Integer;
  
begin
  DepthComboBox.ItemIndex := 4;
  AccelLabel.Caption := '';
  for I := 1 to 32 do
    FColorBits[I] := clNone;
  for I := 1 to 64 do
    FAccumBits[I] := clNone;
  with FlagsCheckBox do
    for I := 0 to Items.Count - 1 do
      Checked[I] := False;
  with ExtensionsCheckBox do
    for I := 0 to Items.Count - 1 do
      Checked[I] := False;
  ColorPaintBox.Invalidate;
  AccumPaintBox.Invalidate;

  VendorLabel.Caption := '';
  RendererLabel.Caption := '';
  GLVersionLabel.Caption := '';
  GLUVersionLabel.Caption := '';
  AttribLabel.Caption := '';
  ClientAttribLabel.Caption := '';
  ClipLabel.Caption := '';
  EvalLabel.Caption := '';
  LightLabel.Caption := '';
  ListLabel.Caption := '';
  ModelviewLabel.Caption := '';
  NameStackLabel.Caption := '';
  PixelmapLabel.Caption := '';
  ProjectionLabel.Caption := '';
  TextureLabel.Caption := '';
  TextureStackLabel.Caption := '';
  ViewportLabel.Caption := '';
  SubpixelLabel.Caption := '';

  ConvWidthLabel.Caption := '';
  ConvHeightLabel.Caption := '';
  ColorStackLabel.Caption := '';

  Texture3DLabel.Caption := '';

  VerticesLabel.Caption := '';
  IndicesLabel.Caption := '';
  LODLabel.Caption := '';
  TextureLevelLabel.Caption := '';

  PointSizeLabel.Caption := '';

  TextureUnitsLabel.Caption := '';

  PFDBrowseBtn.Enabled := False;
  PFDCount.Caption := '0 of 0';
end;                                     

//----------------------------------------------------------------------------------------------------------------------

initialization
  IsWinNT := Win32Platform = VER_PLATFORM_WIN32_NT;
end.
